Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.functions.regex
Class JRegexIterator

    java.lang.Object
      net.sf.saxon.functions.regex.JRegexIterator

All Implemented Interfaces:
  RegexIterator, SequenceIterator

    public class JRegexIterator

extends Object
implements RegexIterator

Class JRegexIterator - provides an iterator over matched and unmatched substrings. This implementation of RegexIterator uses the JDK regular expression engine.

Nested Class Summary

Nested classes/interfaces inherited from interface net.sf.saxon.functions.regex.RegexIterator
`RegexIterator.OnGroup`

Field Summary

Fields inherited from interface net.sf.saxon.om.SequenceIterator
`GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

Constructor Summary
`JRegexIterator(String string, Pattern pattern)` Construct a RegexIterator.

Method Summary
`void` | `close()` Close the iterator.
`Item` | `current()` Get the current item in the sequence
`SequenceIterator` | `getAnother()` Get another iterator over the same items
`int` | `getProperties()` Get properties of this iterator, as a bit-significant integer.
`String` | `getRegexGroup(int number)` Get a substring that matches a parenthesised group within the regular expression
`SequenceIterator` | `getRegexGroupIterator()` Get a sequence containing all the regex groups (except group 0, because we want to use indexing from 1).
`boolean` | `isMatching()` Determine whether the current item is a matching item or a non-matching item
`Item` | `next()` Get the next item in the sequence
`int` | `position()` Get the position of the current item in the sequence
`void` | `processMatchingSubstring(XPathContext context, RegexIterator.OnGroup action)` Process a matching substring, performing specified actions at the start and end of each captured subgroup.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### JRegexIterator

    public JRegexIterator(String string,
                          Pattern pattern)

  Construct a RegexIterator. Note that the underlying matcher.find() method is called once to obtain each matching substring. But the iterator also returns non-matching substrings if these appear between the matching substrings.

  Parameters:
    `string` - the string to be analysed
    `pattern` - the regular expression

Method Detail

### next

    public Item next()

  Get the next item in the sequence

  Specified by:
    `next` in interface `SequenceIterator`
  Returns:
    the next item in the sequence

### current

    public Item current()

  Get the current item in the sequence

  Specified by:
    `current` in interface `SequenceIterator`
  Returns:
    the item most recently returned by next()

### position

    public int position()

  Get the position of the current item in the sequence

  Specified by:
    `position` in interface `SequenceIterator`
  Returns:
    the position of the item most recently returned by next(), starting at 1

### close

    public void close()

  Description copied from interface: `SequenceIterator`
  Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

  (Currently, closing an iterator is important only when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.)

  Specified by:
    `close` in interface `SequenceIterator`

### getAnother

    public SequenceIterator getAnother()

  Get another iterator over the same items

  Specified by:
    `getAnother` in interface `SequenceIterator`
  Returns:
    a new iterator, positioned before the first item

### getProperties

    public int getProperties()

  Get properties of this iterator, as a bit-significant integer.

  Specified by:
    `getProperties` in interface `SequenceIterator`
  Returns:
    the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED`, `SequenceIterator.LAST_POSITION_FINDER`, and `SequenceIterator.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

### isMatching

    public boolean isMatching()

  Determine whether the current item is a matching item or a non-matching item

  Specified by:
    `isMatching` in interface `RegexIterator`
  Returns:
    true if the current item (the one most recently returned by next()) is an item that matches the regular expression, or false if it is an item that does not match

### getRegexGroup

    public String getRegexGroup(int number)

  Get a substring that matches a parenthesised group within the regular expression

  Specified by:
    `getRegexGroup` in interface `RegexIterator`
  Parameters:
    `number` - the number of the group to be obtained
  Returns:
    the substring of the current item that matches the n'th parenthesized group within the regular expression

### getRegexGroupIterator

    public SequenceIterator getRegexGroupIterator()

  Get a sequence containing all the regex groups (except group 0, because we want to use indexing from 1). This is used by the saxon:analyze-string() higher-order extension function.

  Specified by:
    `getRegexGroupIterator` in interface `RegexIterator`

### processMatchingSubstring

    public void processMatchingSubstring(XPathContext context,
                                         RegexIterator.OnGroup action)
                                  throws XPathException

  Process a matching substring, performing specified actions at the start and end of each captured subgroup. This method will always be called when operating in "push" mode; it writes its result to context.getReceiver(). The matching substring text is all written to the receiver, interspersed with calls to the `RegexIterator.OnGroup` methods onGroupStart() and onGroupEnd().

  Specified by:
    `processMatchingSubstring` in interface `RegexIterator`
  Parameters:
    `context` - the dynamic evaluation context
    `action` - defines the processing to be performed at the start and end of a group
  Throws:
    `XPathException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.